#pragma once

const SMischen = 1, SSprung = 2, SAuto = 4, SGesperrt = 8, SVerdeckt = 16, SStopp1 = 32, SStopp2 = 64
const SFarbstart = 128, SWertstart = 256, SQuer = 512, SBelegt = 2^10, SVoll = 2*2^10, SFrei = 3*2^10
const SJoker = 2^12
const MOr = 0, MAnd = 1024, MXor = 2048
const SsLeer = 1, SsBelegt = 2, SsBelegbar = 3, SsVoll = 4, SsStopp = 5, SsKeinStopp = 6, SsSumme = 7
const SsLegen = 8, SsNehmen = 16, SsInaktiv = 32
const VGleich = 1*2^8, VGroesser = 2*2^8, VKleiner = 4*2^8, VVergleich = VGleich or VGroesser or VKleiner
const VFarbwechsel = 1*2^11, VFarbgleich = 2*2^11, VFarbSR = 3*2^11, VFarbungleich = 4*2^11
const VFarbvergleich = VFarbwechsel or VFarbgleich or VFarbSR or VFarbungleich
const ROben = 1, RUnten = 2, RLinks = 4, RRechts = 8
const ASumme = 48, AKartenzahl = 16, AFarbe = 32, AWert = 48
const ATypLinks = 1, ATypRechts = 2, ATypMitte = 4, ATypLegen = 8, ATypFrei = 15
const ATypAbschluss = 16, ATypIrreversibel = 32, ATypBeginn = 64, ATypSieg = 128, ATypVerlust = 256, ATypKeinAuto = 512
const ATypKlick = ATypLinks or ATypRechts, ATypEnde = ATypSieg or ATypVerlust
const ChEinzel = 0, ChId = 1, ChKomplett = 2, ChGesamt = 3, ChTausch = 4, ChMischen = 2^3
const ChAenderung = 2^4, ChLegen = 2*2^4, ChSound = 3*2^4, ChWarten = 4*2^4, ChMeldung = 2^7
const ChLegeRueckwaerts = 2^8, ChLegeMischen = 2^9, ChLegeZufall = 2^10
const ChEinschubHinten = 2^11, ChEinschubZufall = 2^12, ChErlaubt = 2^13, ChUmschichtenAuf = 2^15
const ChUmschichtenAb = 2^16, ChLegeEinmal = 2^17, ChAniOffen = 2^18, ChAniVerdeckt = 2*2^18
const ChAniFrei = ChAniOffen or ChAniVerdeckt, ChVerdeckt = 2^20, ChOffen = 2^21, ChSpielende = 2^22, ChGlobal = 2^23
const EndeSieg = 1, EndeVerlust = 2, EndeSpeichern = 3, EndeNeu = 4, EndeSiegUndNeu = 5
const EndeFileNotFound = 6, EndeFehler = 0
const Offen = 0, Leer = 1, Verdeckt = 2
const Hintergrund2 = 1
const Herz = 1, Kreuz = 2, Karo = 3, Pik = 4, Rot = 5, Schwarz = 6
const K2 = 2, K3 = 3, K4 = 4, K5 = 5, K6 = 6, K7 = 7, K8 = 8, K9 = 9, K10 = 10, KB = 11, KD = 12, KK = 13, KA = 14
const TStapel = 0, TStock = 1, TAbwurf = 2, TGrund = 3, THilf = 4, TKeller = 5, TReserve = 6
const SOUND_MUSIK_OK = 1, SOUND_MUSIK_ON = 2, SOUND_EFFEKT_OK = 4, SOUND_EFFEKT_ON = 8
const BRand = 1, BGrau = 2

enum Fehler
  allesOk = 0
  dateiNichtGefunden, speicherstandZuAlt, speicherstandZuNeu
end enum

enum Listentyp
  ListAnzeige = 1, ListSperre, ListSchiebsperre, ListStopp, ListQuelle, ListZiel
  ListBeziehung, ListPunkte, ListBedingung, ListVergleich, ListAenderung
end enum

type TypListeninhalt
  as integer typ
  as string id, inhalt, bedingung, spec
end type
type TypListe
  as TypListeninhalt _inhalt(any)
  as string ablauf
  declare property position(nr as integer) as long
  declare property erster(nr as integer) as long
  declare property naechster(nr as integer) as long
  declare property id(nr as integer, wert as string)
  declare property id(nr as integer) as string
  declare property inhalt(nr as integer, wert as string)
  declare property inhalt(nr as integer) as string
  declare property bedingung(nr as integer, wert as string)
  declare property bedingung(nr as integer) as string
  declare property spec(nr as integer, wert as string)
  declare property spec(nr as integer) as string
end type
property TypListe.position(nr as integer) as long
  if nr < 1 or nr > len(this.ablauf)\12 then return 0
  return cvl(mid(this.ablauf, nr*12 - 11, 4))
end property
property TypListe.erster(nr as integer) as long
  if nr < 1 or nr > len(this.ablauf)\12 then return 0
  return cvl(mid(this.ablauf, nr*12 - 7, 4))
end property
property TypListe.naechster(nr as integer) as long
  if nr < 1 or nr > len(this.ablauf)\12 then return 0
  return cvl(mid(this.ablauf, nr*12 - 3, 4))
end property
property TypListe.id(nr as integer, wert as string)
  if nr < 1 or nr > len(this.ablauf)\12 then exit property
  _inhalt(this.position(nr)).id = wert
end property
property TypListe.id(nr as integer) as string
  if nr < 1 or nr > len(this.ablauf)\12 then return ""
  return _inhalt(this.position(nr)).id
end property
property TypListe.inhalt(nr as integer, wert as string)
  if nr < 1 or nr > len(this.ablauf)\12 then exit property
  _inhalt(this.position(nr)).inhalt = wert
end property
property TypListe.inhalt(nr as integer) as string
  if nr < 1 or nr > len(this.ablauf)\12 then return ""
  return _inhalt(this.position(nr)).inhalt
end property
property TypListe.bedingung(nr as integer, wert as string)
  if nr < 1 or nr > len(this.ablauf)\12 then exit property
  _inhalt(this.position(nr)).bedingung = wert
end property
property TypListe.bedingung(nr as integer) as string
  if nr < 1 or nr > len(this.ablauf)\12 then return ""
  return _inhalt(this.position(nr)).bedingung
end property
property TypListe.spec(nr as integer, wert as string)
  if nr < 1 or nr > len(this.ablauf)\12 then exit property
  _inhalt(this.position(nr)).spec = wert
end property
property TypListe.spec(nr as integer) as string
  if nr < 1 or nr > len(this.ablauf)\12 then return ""
  return _inhalt(this.position(nr)).spec
end property
dim shared as TypListe liste

type TypButton
  as integer x, y, b, h, opt
  as string text
  declare constructor
  declare constructor(x as integer, y as integer, b as integer, h as integer, opt as integer, text as string)
  declare function in(x as integer, y as integer) as integer
  declare sub zeichnen(mark as integer = 0)
end type
constructor TypButton
  this = type<TypButton>(-1, -1, 0, 0, BRand, "")
end constructor
constructor TypButton(x as integer, y as integer, b as integer, h as integer, opt as integer, text as string)
  this.x = x
  this.y = y
  this.b = b
  this.h = h
  this.text = text
  this.opt = opt
end constructor
function TypButton.in(x as integer, y as integer) as integer
  if (x >= this.x) and (x <= this.x + this.b) and (y >= this.y) and (y <= this.y + this.h) then return -1
  return 0
end function
sub TypButton.zeichnen(mark as integer = 0)
  dim as integer whoehe, zhoehe, farbe1, farbe2, farbe3
  screeninfo , whoehe
  zhoehe = whoehe \ hiword(width)
  if this.h > 0 then
    select case mark
      case 0 : farbe1 = FGC   : farbe2 = BGC   : farbe3 = FGC   ' normal
      case 1 : farbe1 = FGC   : farbe2 = FGC   : farbe3 = BGC   ' aktiv
      case 2 : farbe1 = FGC   : farbe2 = DGRAU : farbe3 = HGRAU ' markiert
      case 3 : farbe1 = DGRAU : farbe2 = BGC   : farbe3 = DGRAU ' deaktiviert
    end select
    line (this.x, this.y)-step(this.b-2, this.h-2), farbe2, bf
    line (this.x, this.y)-step(this.b-1, this.h-1), farbe1, b
    if this.opt and BRand then line (this.x+1, this.y+1)-step(this.b-3, this.h-3), farbe1, b
    draw string (this.x+this.b\2 - 4*len(this.text) + 1, this.y+this.h\2 - zhoehe\2 + 1), this.text, farbe3
  else
    line (this.x, this.y)-step(this.b-1, 16), BGC, bf
    draw string (this.x+this.b\2 - 4*len(this.text), this.y + 1), this.text
  end if
end sub

type TypPatience
  as string url, name, sortname, fenstername, anleitung, regel(1 to 9), regelID(1 to 9)
  as integer patversion, onlineversion, programmversion, levelmax, inaktiv, gewonnen(1 to 9), verloren(1 to 9)
  as integer punkte(1 to 9, 24), punktsumme(1 to 9), zeitgewinnmin(1 to 9), zeitgewinnmax(1 to 9), punktemax
  as integer zeitgewinnsumme(1 to 9), zeitverliermin(1 to 9), zeitverliermax(1 to 9), zeitverliersumme(1 to 9)
  as integer level(1 to 9), regelanz, regelaktiv, schnitt(9)
end type

type TypKarte
  as byte farbe, wert
  as short status, spezial
end type

type TypFeldinfo
  as ubyte kuerzel, verdeckt, karten, richtung
  as integer x, y, eng, karte(0 to 207), kartenmax, spezial, sichtbar
  as string id, typ
end type

type TypFeld
  as TypKarte karte(208)
  as long     max, x, y, wiederholung, spezial, rand, eng, startfarbe, startwert, endwert, variable
  as long     llastQuellen, llastZiele, llastSperren, llastSchiebsperren, llastStopps, llastAnzeigen, llastBeziehung, llastPunkte
  as ubyte    kuerzel, anzkarten, anfangskarten(26), richtung, sichtbar, sichtbarAnfang
  as string   id, folgestart, folgefarbe, folgewert, folgeschieb, fuellen, einschub, auto
  declare property anfang(nr as integer, wert as integer)
  declare property anfang(nr as integer) as integer
end type
property TypFeld.anfang(nr as integer, wert as integer)
  if nr < 0 or nr > 207 then exit property
  if this.anfangskarten(0) < nr+1 then this.anfangskarten(0) = nr+1
  if wert = 0 then
    this.anfangskarten(nr\8 + 1) = bitreset(this.anfangskarten(nr\8 + 1), nr mod 8)
  elseif wert = 1 then
    this.anfangskarten(nr\8 + 1) = bitset(this.anfangskarten(nr\8 + 1), nr mod 8)
  end if
end property
property TypFeld.anfang(nr as integer) as integer
  if nr < 0 or nr >= this.anfangskarten(0) then return -1
  return -bit(this.anfangskarten(nr\8 + 1), nr mod 8)
end property

type TypVorlage
  as TypFeld felddaten
  as integer listenlaenge
  as TypXML legeliste(0 to 999)
end type

type TypAktion
  as long    typ, erfolg, misserfolg, llastBedingung, llastVergleich, llastAenderung
  as string  id, erfstring, misstring
end type

type TypTisch
  as integer stapel, nr
  as TypKarte karte
end type

type TypGrafikbuffer
  as integer x, y, b, h
  as FB.Image ptr bild
end type

type TypSpiel
  as integer maxX, maxY, kartenset, karten, felder
  as TypFeldinfo feld(1 to 220)
end type

type TypHauptsetting
  as TypButton spieler, mpunkt(1 to 3), apunkt(any), hpunkt(any), regelwahl, regeltext, soundEinAus, animation
  as TypButton weiter, zurueck, einstellung, danksagung, ende, tischfarbe, infosOk, helpSpielen, helpEnde
  as TypButton setMinus, setPlus, setText, groesseMinus, groessePlus, groesseText
  as TypButton rueckenMinus, rueckenPlus, rueckenText, rueckenVar
  as string datapfad, benutzer, SpielerSet, SpielerRuecken
  as integer onlineversion, allezahl = 0, aktuellzahl = 0, menuwahl = 1
  as integer SpielerTischfarbe, SpielerRueckenVar
  as boolean SpielerSound, SpielerAnimation
end type
dim shared as TypHauptsetting hauptsetting

type TypSpielsetting
  as long anzVorlagen, anzFelder, anzAktionen, anzAbschluss, anzListeninhalt
  as long maxX, maxY, kartenset, anzKarten, zufallsfarbe, zufallswert
  as long stopp, punkte, punktemax, punktestart, level, backpunkte, aktuellerScreen, Standardstock
  as long Spielversion, markStopp, markKorrekt, regel, BGC
  as integer _Neuzeichnen, kartenWaag, kartenSenk, groesse, sound, animation
  as integer programmende, rueckenVar, endevariante
  as string spieldatei, spielername, spielregel, spielname, bemerkung, anleitung, kartenbilder, ruecken
  as TypFeld feld(any), backfeld(any)
  as TypAktion aktion(any), abschluss(any)
  as TypKarte stapel(207)
  as TypTisch tisch(any, any)
  as FB.Image ptr kartenbild(55), kartenbildQuer(55)
  as TypVorlage vorlage(any)
end type
dim shared as TypSpielsetting Setting

' DECLAREs für patcommon.bi
declare function ersetzeZeichenkette(text as string, alt as string, neu as string) as string
declare function ersetzeUmlaute(text as string, fenster as integer = 0) as string

declare function nachricht(meldung as string, buttons as string = " OK ") as integer
declare sub richtungsadd(as integer, byref as integer, byref as integer, as integer, as integer, as integer, as integer)
declare function sucheRichtung(text as string) as integer

' DECLAREs für patfinder.bi
declare sub hauptprogramm
declare sub auswahlbildschirm(patliste() as TypPatience, pstart as integer)
declare function auswahl(patliste() as TypPatience, byref pstart as integer) as integer
declare sub credits
declare function datenLesen(xml as TypXml) as TypPatience
declare function eingabe(x as integer, y as integer, typ as integer = 0) as string
declare function einstellungen as boolean
declare sub hauptmenuZeichnen
declare sub hauptsettingSetzen
declare function info(pat as TypPatience) as boolean
declare sub infoStatistik(pat as TypPatience, punkteschnitt as string)
declare sub quicksort overload (a() as string, byval s as integer = 0, byval e as integer = &hffff)
declare sub quicksort(array() as TypPatience, byval start as integer = 0, byval ende as integer = &hffff)
declare function sortname(text as string) as string
declare sub spielParse(pat as TypPatience, spiel as TypSpiel, xmlrest as string, _
                       vorlage() as TypFeldinfo, anzVorlagen as integer)
declare sub spielStarten(pat as TypPatience)
declare sub statistikEinlesen(benutzer as string, byref pat as TypPatience)
declare function sucheBild(bilderliste() as string, altesBild as integer, groesse as integer) as integer
declare sub tischZeichnen(tisch as integer, vorn as FB.Image ptr, hinten as FB.Image ptr, hinten2 as FB.Image ptr, _
                          breite as integer, ruecken as integer)

' DECLAREs für patwork.bi
declare function patwork(url as string, regel as integer, level as integer, _
                         benutzer as string, randominit as double = -1) as integer
declare function aktionslauf(typ as integer, ziel as TypTisch, start as TypTisch = type<TypTisch>(0), _
                             legen as integer = -1, auto as boolean = false) as integer
declare function attribut(stapel as integer, attr as string, spec as string) as string
declare sub ausgrauen(ziel as TypTisch)
declare sub backup
declare sub berechneTisch
declare sub bewege(startfeld as TypTisch, zielstapel as integer, zielnr as integer = -1, _
                   byval typ as integer = 0, byval anz as integer = 0)
declare sub dupliziereListen(quelle as TypFeld, ziel as TypFeld)
declare function exitTest(taste as string) as integer
declare sub feldInit(datei as string)
declare sub feldInitParse(xmlrest as string, tag as string = "")
declare sub initParseLegeSortiere(xml as TypXML, feldptr as TypFeld ptr)
declare function findeFeld(xx as integer, yy as integer) as TypTisch
declare sub hilfe
declare function karte2wert(k as TypKarte) as integer
declare function kartenwert(k as TypKarte) as integer
declare function kartenwertParse(inhalt as string) as TypKarte
declare function legeversuch(start as TypTisch, ziel as TypTisch, legen as integer = -1, _
                             richtung as integer = 1, aktion as integer = -1, stockauf as integer = 0, _
                             anz as integer = 0, auto as boolean = false) as integer
declare sub lege(start as TypTisch, ziel as TypTisch, richtung as integer = 1, einschubstopp as integer = -1, _
                 stockauf as integer = 0, byval anz as integer = 0)
declare function listeAdd overload(l as integer, inhalt as integer) as integer
declare function listeAdd(l as integer, typ as integer, id as string, inh as string, bed as string, spec as string) as integer
declare function menu as integer
declare sub menuleiste(txt as string = "")
declare function parseLinks(text as string, start as integer, ziel as integer) as string
declare function parseVariablen(text as string) as string
declare function pruefeAuto(start as TypTisch, ziel as integer) as integer
declare function pruefeFolge(feld as TypFeld) as integer
declare function pruefeSperre(ziel as integer, typ as integer, start as integer = 0) as integer
declare function pruefeVerschiebbar(start as TypTisch) as integer
declare function pruefeWerte(wert1 as integer, wert2 as integer, vergleich as integer) as integer
declare sub setzeAttribut(feldptr as TypFeld ptr, attr as string, wert as string, spec as string = "")
declare sub setzeBildschirm
declare sub setzeJoker(byref f as TypFeld, nr as integer)
declare sub sound_spielen(byval sound as uinteger)
declare function spielEnde(status as integer) as integer
declare function spielLaden as Fehler
declare sub spielSpeichern
declare sub stockaktion(start as TypTisch, ziel as TypTisch = type<TypTisch>(0, 0), sperrung as integer = -1)
declare sub stockaufnahme(start as TypTisch)
declare sub stopptest(start as TypTisch, ziel as TypTisch, einschubstopp as integer = -1)
declare function tempfeld(sfarbe as integer, swert as integer, ewert as integer, ffarbe as string, fwert as string, _
                 fschieb as string, einschub as string, mmax as integer, spezial as integer, k() as TypKarte) as TypFeld
declare function wert2karte(wert as integer) as TypKarte
declare sub zeichne(opt as integer = 0)
declare sub zeichneKarte(x as integer, y as integer, wert as integer, quer as integer = 0)
