' XML-Parser v120403

#Define leerzeichen  32
#Define quoteDoppelt 34
#Define quoteEinfach 39
#Define slash        47
#Define klammerAuf   60
#Define klammerZu    62

Type TypXML
  As String tag,       _  ' Name des ersten auffindbaren Tags
            attribute, _  ' enthaelt alle Attribute
            inhalt,    _  ' alles innerhalb des Tags; kann weitere Tags enthalten
            vorspann,  _  ' alles vor dem ersten auffindbaren Tag
            rest,      _  ' alles nach dem Schliesstag; kann weitere Tags enthalten
            fehler        ' Fehlermeldung, falls ein Fehler auftrat; sonst leer
  ' GetAttr liest den Inhalt des angegebenen Attributs
  ' existiert das Attribut nicht, dann wird ein Leerstring zurueckgegeben
  ' Es findet keine Zwischenspeicherung statt; GetAttr sollte je Tag und Attribut nur einmal aufgerufen werden.
  Declare Function GetAttr(attr As String) As String
End Type

declare sub xmlBaum(daten as string, ebene as integer = 0)
declare function xmlErsetzung(eingabe as string, original as string, ersetzung as string) as string
declare function xmlParse (eingabe as string = "", datei as integer = 0) as TypXML
declare function TypXML_suchestring(eingabe as string, suchstring as string, datei as integer, _
                            ueberspringeTag as string = "") as TypXML

sub xmlBaum(daten as string, ebene as integer = 0)
  ' zeigt eine Baumstruktur der Tags einer Datei an
  ' Beim Aufruf enthaelt 'daten' den Dateinamen, 'ebene' wird leer gelassen.
  dim as TypXML tempxml
  if ebene = 0 then
    dim as integer f = freefile
    open daten for input as #f
    tempxml = xmlparse(, f)
    close #f
  else
    tempxml = xmlparse(daten)
  end if
  if tempxml.fehler <> "" then print "*** FEHLER: " & tempxml.fehler & " ***"
  do
    if trim(tempxml.vorspann) <> "" then print space(ebene*2); tempxml.vorspann
    if tempxml.tag = "" then exit sub
    print space(ebene*2); "<"; tempxml.tag; tempxml.attribute; ">"
    xmlBaum(tempxml.inhalt, ebene+1)
    print space(ebene*2); "</"; tempxml.tag;">"
    ' Rest bis zur naechsten Spitzklammer anzeigen
    dim rest as string = trim(tempxml.rest), such as integer = instr(rest, "<")
    if such > 1 then
      print space(ebene*2); trim(left(tempxml.rest, such-1))
    elseif such <> 1 and rest <> "" then
      print space(ebene*2); rest
    end if
    tempxml = xmlparse(tempxml.rest)
  loop until tempxml.tag = ""
end sub

function xmlErsetzung(eingabe as string, original as string, ersetzung as string) as string
  ' ersetze in 'eingabe' den Teilstring 'original' durch 'ersetzung'
  dim z as integer, ret as string = eingabe
  do
    z = instr(ret, original)
    if z = 0 then exit do
    ret = left(ret, z-1) & ersetzung & mid(eingabe, z+len(original))
  loop
  return ret
end function

function xmlParse(eingabe as string = "", datei as integer = 0) as TypXML
  dim ret as TypXML, tempxml as TypXML, tempstring as string
  if datei = 0 then tempstring = eingabe
  dim as integer suche, suche2, tempint, leeresTag
  ' suche nach Verarbeitungsanweisungen <?... ?> und DOCTYPE-Deklaration <!DOCTYPE ... >
  ' (beide werden komplett ignoriert!)
  if tempstring = "" andalso not eof(datei) then line input #datei, tempstring
  do
    suche = instr(tempstring, "<?")
    if suche = 0 then exit do
    tempint = suche + 2
    tempxml = TypXML_suchestring(mid(tempstring, tempint), "?>", datei)
    if tempxml.fehler <> "" then
      ret.fehler = "Nicht geschlossene Verarbeitungsanweisung"
      return tempxml
    end if
    tempstring = left(tempstring, suche-1) & tempxml.rest
  loop
  do
    suche = instr(tempstring, "<!DOCTYPE")
    if suche = 0 then exit do
    tempint = suche + 9
    tempxml = TypXML_suchestring(mid(tempstring, tempint), ">", datei)
    if tempxml.fehler <> "" then
      ret.fehler = "Nicht geschlossene Deklaration"
      return ret
    end if
    tempstring = left(tempstring, suche-1) & tempxml.rest
  loop
  ' suche nach Kommentaren
  do
    suche = instr(tempstring, "<!--")
    if suche = 0 then exit do
    tempint = suche + 4
    tempxml = TypXML_suchestring(mid(tempstring, tempint), "-->", datei)
    if tempxml.fehler <> "" then
      ret.fehler = "Nicht geschlossener Kommentar"
      return ret
    end if
    tempstring = left(tempstring, suche-1) & tempxml.rest
  loop
  ' suche oeffnende Spitzklammer
  do
    suche = instr(tempstring, "<")
    if suche = 0 then
      ret.vorspann &= tempstring & " "
      if eof(datei) then return ret
      line input #datei, tempstring
    else
      ret.vorspann &= left(tempstring, suche-1)
      tempstring = mid(tempstring, suche+1)
      exit do
    end if
  loop
  ' ret.vorspann wurde gefunden; eingabe beginnt nun mit dem ersten XML-Tag
  leeresTag = 0  ' regulaer sind Tags nicht leer
  suche = instr(tempstring & " ", any chr(9) & " >")
  if tempstring[suche-2] = slash then
    if suche < 4 then
      ret.fehler = "Unerlaubte Spitzklammer '<'"
      return ret
    end if
    ret.tag = mid(tempstring, 1, suche-2)
  else
    if suche < 3 then
      ret.fehler = "Unerlaubte Spitzklammer '<'"
      return ret
    end if
    ret.tag = mid(tempstring, 1, suche-1)
  end if
  tempstring = mid(tempstring, suche)
  ' suche zugehoerige schliessende Spitzklammer
  do
    suche = instr(tempstring, ">")
    if suche = 0 then
      ret.attribute &= tempstring & " "
      if eof(datei) then
        ret.fehler = "Fehlende Spitzklammer '>'"
        return ret
      else
        line input #datei, tempstring
      end if
    else
      if tempstring[suche-2] = slash then
        leeresTag = -1
        tempstring = left(tempstring, suche-2) & mid(tempstring, suche)
        suche -= 1
      end if
      ret.attribute &= left(tempstring, suche-1)
      tempstring = mid(tempstring, suche+1)
      exit do
    end if
  print "!" & left(tempstring, 70)
  loop
  ' suche zugehoerigen End-Tag
  if leeresTag then
    if tempstring = "" andalso not eof(datei) then line input #datei, ret.rest
    'tempstring = "</" & ret.tag & ">" & tempstring
    ret.rest = tempstring
    ret.vorspann = trim(ret.vorspann)
    ret.attribute = rtrim(ret.attribute)
    ret.inhalt = ""
  else
    tempxml = TypXML_suchestring(tempstring, "</" & ret.tag & ">", datei, ret.tag)
    if tempxml.fehler <> "" then
      ret.fehler = "Fehlendes End-Tag"
      return ret
    end if
    tempstring = left(tempstring, suche-1) & tempxml.rest
    ret.rest = tempxml.rest
    ret.vorspann = trim(ret.vorspann)
    ret.attribute = rtrim(ret.attribute)
    ret.inhalt = trim(tempxml.inhalt)
  end if
  return ret
end function

function TypXML.GetAttr(attr as string) as string
  dim as integer suche1, suche2, temp
  suche1 = instr(lcase(this.attribute), " " & lcase(attr) & chr(61, 34))     ' doppeltes Anfuehrungszeichen
  if suche1 > 0 then
    temp = suche1 + len(attr) + 3
    suche2 = instr(temp, this.attribute, chr(34))
    if suche2 = 0 then
      this.fehler = "Fehlendes Anfuehrungszeichen zum Attribut-Ende"
      return ""
    end if
    return mid(this.attribute, temp, suche2-temp)
  else
    suche1 = instr(lcase(this.attribute), lcase(attr) & chr(61, 39))   ' einfaches Anfuehrungszeichen
    if suche1 > 0 then
      temp = suche1 + len(attr) + 2
      suche2 = instr(temp, this.attribute, chr(39))
      if suche2 = 0 then
        this.fehler = "Fehlendes Anfuehrungszeichen zum Attribut-Ende"
        return ""
      end if
      return mid(this.attribute, temp, suche2-temp)
    end if
  end if
  this.fehler = "Fehlendes Attribut"
  return ""
end function

function TypXML_suchestring(eingabe as string, suchstring as string, datei as integer, _
                            ueberspringeTag as string = "") as TypXML
  dim as TypXML ret
  dim as integer suche, suche2, suche3, tempint = 1, tempint2 = 1, tempint3
  dim as string string1 = eingabe, string2
  do
    suche = instr(tempint, string1, suchstring)
    if suche = 0 then
      if eof(datei) then
        ret.fehler = "gesuchten String nicht gefunden"
        return ret
      end if
      tempint = len(string1)
      line input #datei, string2
      string1 &= string2
    end if
    if ueberspringeTag <> "" then
      tempint2 = tempint
      do
        suche2 = instr(tempint2, string1, "<" & ueberspringeTag)
        if suche2 = 0 or suche2 > suche then exit do
        dim as integer weiter = string1[suche2+len(ueberspringeTag)]
        if weiter <> leerzeichen and weiter <> slash and weiter <> klammerZu then
          tempint2 = suche2+len(ueberspringeTag)
          continue do
        end if
        ' Verschachtelung gefunden; diese muss erst aufgelöst werden
        tempint3 = suche2
        ' suche zugehoerige schliessende Spitzklammer
        do
          suche3 = instr(tempint3, string1, ">")
          if suche3 = 0 then
            if eof(datei) then
              ret.fehler = "gesuchten String nicht gefunden"
              exit do, do, do
            else
              tempint3 = len(string1)
              line input #datei, string2
              string1 &= string2
            end if
          else
            if string1[suche3-2] <> slash then
              ' zugehoeriges Endtag suchen
              ret = TypXML_suchestring(mid(string1, suche3+1), "</" & ueberspringeTag & ">", datei, ueberspringeTag)
              if ret.fehler <> "" then exit do, do, do
              tempint = len(string1) - len(ret.rest)
            end if
            tempint2 = suche3
          end if
        loop until suche3 > 0
        suche = 0  ' alte Suche ist jetzt ungueltig und muss wiederholt werden
      loop
    end if
  loop until suche > 0
  ret.inhalt = left(string1, suche - 1)
  ret.rest = mid(string1, suche + len(suchstring))
  if ret.rest = "" andalso not eof(datei) then line input #datei, ret.rest
  return ret
end function

#undef leerzeichen
#undef quoteDoppelt
#undef quoteEinfach
#undef slash
#undef klammerAuf
#undef klammerZu
