#define SND   ' auskommentieren, um keinen Sound zu verwenden

const PATFINDER_MAJOR = 3
const PATFINDER_MINOR = 0
const PATFINDER_PATCH = 220828
const as ulong PROGRAMMVERSION = PATFINDER_MAJOR*&h10000000 + PATFINDER_MINOR*&h100000 + PATFINDER_PATCH
const as ulong SPEICHERSTAND_MINVERSION = 2*&h10000000 + 0*&h100000
const BGC = &h000000, FGC = &hffffff, HGRAU = &hbbbbbb, DGRAU = &h555555, CROT = &hff1111, MBC = &h222222

#include once "include/xmlparse.bas"
#include once "include/http.bas"
#include once "vbcompat.bi"
#include once "fbgfx.bi"
#include once "include/patinc.bi"
#if defined(__FB_UNIX__)
  const root = "./", slash = "/"
#elseif defined(__FB_PCOS__)
  const root = "", slash = "\"
#else
  #error "Fehler: Unbekanntes Betriebssystem!"
#endif
#ifdef SND
  #include once "bass.bi"
#endif

chdir exepath
dim as integer f = freefile
open "datenpfad" for input as #f
line input #f, hauptsetting.datapfad
close #f

' Sound initialisieren
dim shared as string FILE_LEGEN, FILE_MISCH
FILE_LEGEN = "snd" & slash & "legen.ogg"
FILE_MISCH = "snd" & slash & "misch.ogg"
dim shared as uinteger sound = -1, sound_legen, sound_misch
#ifdef SND
  if sound <> 0 andalso BASS_Init(-1, 44100, BASS_DEVICE_8BITS, 0, 0) <> 0 then
    sound = SOUND_EFFEKT_OK
  end if
  if sound > 0 then
    sound_legen = BASS_SampleLoad(0, strptr(FILE_LEGEN), 0, 0, 16, 0)
    sound_misch = BASS_SampleLoad(0, strptr(FILE_MISCH), 0, 0, 16, 0)
  end if
#endif
if sound < 0 then sound = 0

#include once "include/patcommon.bi"
#include "include/patfinder.bi"
#include "include/patwork.bi"

' Kommandozeilen-Argumente auswerten
if __FB_ARGC__ > 1 then
  dim as integer regel = 0, level = 0
  dim as double randominit = -1
  dim as string spielername
  dim as string spieldatei = *__FB_ARGV__[1]
  select case spieldatei
    ' einzelner Optionsschalter
    case "-v", "-version"
      print PROGRAMMVERSION
      end
    case "-h", "-hilfe"
      print "patfinder Version " & PATFINDER_MAJOR & "." & PATFINDER_MINOR & "." & PATFINDER_PATCH
      print "Aufruf:"
      print "patwork Patience [-l Level] [-r Regelset] [-n Spielername]"
      print "startet die Patience, die unter Patience.xml gespeichert"
      print "ist, und verwendet dabei das angegebene Level sowie das"
      print "Regelset mit der angegebenen Nummer"
      print
      print "patwork -[h|v|c]"
      print "-h:  Dieser Hilfstext"
      print "-v:  Rueckgabe der patwork-Revisionsnummer"
      print
      print "Um eine Auswahl der verfuegbaren Patiencen zu erhalten,"
      print "starten Sie stattdessen das Programm patfinder"
      print
      end
  end select
  dim as integer argument = 2
  do while argument < __FB_ARGC__
    select case *__FB_ARGV__[argument]
    case "-l", "-level"
      argument += 1
      if argument < __FB_ARGC__ then level = valint(*__FB_ARGV__[argument])
      if level < 0 then level = 0
    case "-r", "-regel"
      argument += 1
      if argument < __FB_ARGC__ then regel = valint(*__FB_ARGV__[argument])
    case "-n", "-name"
      argument += 1
      if argument < __FB_ARGC__ then spielername = *__FB_ARGV__[argument]
    case "-z", "-zufall"
      argument += 1
      if argument < __FB_ARGC__ then randominit = valint(*__FB_ARGV__[argument])
    end select
    argument += 1
  loop
  patwork spieldatei, regel, level, spielername, randominit
else
  hauptsettingSetzen
  hauptprogramm
end if
